Show / Hide Table of Contents

# Struct IslandState

##### Inherited Members

System.ValueType.Equals(System.Object)
System.ValueType.GetHashCode()
System.ValueType.ToString()
System.Object.Equals(System.Object, System.Object)
System.Object.GetType()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: FFXIVClientStructs.FFXIV.Client.Game.MJI

###### Assembly: FFXIVClientStructs.dll

##### Syntax

    public struct IslandState

### Fields

| Improve this Doc View Source

#### CabinGlamour

The current glamour cast on the Cozy Cabin (if any). Relates to the appropriate sub-row in MJIBuilding.

##### Declaration

    public byte CabinGlamour

##### Field Value

Type | Description
--- | ---
System.Byte |

##### Remarks

This field is not offset by one like CabinLevel; Cabin Level 3 will report here as 2.

| Improve this Doc View Source

#### CabinLevel

The current level of the Cozy Cabin for the Island Sanctuary.

##### Declaration

    public byte CabinLevel

##### Field Value

Type | Description
--- | ---
System.Byte |

##### Remarks

This field is offset by 1 compared to the level present in MJIBuildings. Cabin Level 3 will actually have a value of 3 in this field. This is probably because Cabin Level 0 is "nonexistent"..?

| Improve this Doc View Source

#### CurrentProgress

The current progress of the player, as represented by MJIProgress. Appears to be bound to the island sanctuary "tutorial" more than anything.

##### Declaration

    public byte CurrentProgress

##### Field Value

Type | Description
--- | ---
System.Byte |

| Improve this Doc View Source

#### CurrentRank

The current Sanctuary Rank of the player's island. Controls what buildings/items/recipes are or aren't available to the player, and represented by MJIRank.

##### Declaration

    public byte CurrentRank

##### Field Value

Type | Description
--- | ---
System.Byte |

| Improve this Doc View Source

#### CurrentXP

The XP earned towards the next Island Sanctuary rank. Resets to 0 upon leveling up the Sanctuary.

##### Declaration

    public uint CurrentXP

##### Field Value

Type | Description
--- | ---
System.UInt32 |

| Improve this Doc View Source

#### Farm

A sub-struct representing the Farm's (Cropland's) current state

##### Declaration

    public MJIFarmPasture Farm

##### Field Value

Type | Description
--- | ---
MJIFarmPasture |

| Improve this Doc View Source

#### Granaries

A struct representing the current state of granaries present on the island. See the struct documentation for more information on how to access this data.

##### Declaration

    public MJIGranaries Granaries

##### Field Value

Type | Description
--- | ---
MJIGranaries |

| Improve this Doc View Source

#### GroundsGlamourId

The glamour ID applied to grounds around the Island Sanctuary. Correlates to a subrow in MJIVillageAppearanceUI, row 2.

##### Declaration

    public byte GroundsGlamourId

##### Field Value

Type | Description
--- | ---
System.Byte |

| Improve this Doc View Source

#### LandmarkHoursToCompletion

The current number of hours remaining until a specific Landmark has finished construction.

This value may be zero when there is either no construction or if construction is finished and the landmark needs to be "finalized" by the player.

This array is indexed by the RowID of an MJILandmarkPlace.

##### Declaration

    public byte *LandmarkHoursToCompletion

##### Field Value

Type | Description
--- | ---
System.Byte* |

| Improve this Doc View Source

#### LandmarkIds

The RowID of the MJILandmark present at a specific MJILandmarkPlace.

This array is indexed by the RowID of an MJILandmarkPlace.

##### Declaration

    public byte *LandmarkIds

##### Field Value

Type | Description
--- | ---
System.Byte* |

| Improve this Doc View Source

#### LandmarkUnderConstruction

The current construction status of a landmark at a specific MJILandmarkPlace.

This array is indexed by the RowID of an MJILandmarkPlace.

##### Declaration

    public byte *LandmarkUnderConstruction

##### Field Value

Type | Description
--- | ---
System.Byte* |

| Improve this Doc View Source

#### LockedPouchItems

An array of booleans representing if a specific item is (un)locked. Locked/unavailable items are set to true, while those that are unlocked are false. This array is indexed by RowID from the MJIItemPouch table. An item appears to be unlocked upon being gathered or crafted for the first time. IsPouchItemLocked(UInt16)

##### Declaration

    public byte *LockedPouchItems

##### Field Value

Type | Description
--- | ---
System.Byte* |

| Improve this Doc View Source

#### Pasture

A sub-struct representing the Pasture's current state.

##### Declaration

    public MJIFarmPasture Pasture

##### Field Value

Type | Description
--- | ---
MJIFarmPasture |

| Improve this Doc View Source

#### PathsGlamourId

The glamour ID applied to paths around the Island Sanctuary. Correlates to a subrow in MJIVillageAppearanceUI, row 0.

##### Declaration

    public byte PathsGlamourId

##### Field Value

Type | Description
--- | ---
System.Byte |

| Improve this Doc View Source

#### SlopesGlamourId

The glamour ID applied to slopes around the Island Sanctuary. Correlates to a subrow in MJIVillageAppeareanceUI, row 1.

##### Declaration

    public byte SlopesGlamourId

##### Field Value

Type | Description
--- | ---
System.Byte |

| Improve this Doc View Source

#### UnlockedKeyItems

A bitfield representing all unlocked key items (MJIKeyItem) for the player. Backing field for IsKeyItemUnlocked(UInt16), which should be used where possible.

##### Declaration

    public ushort UnlockedKeyItems

##### Field Value

Type | Description
--- | ---
System.UInt16 |

##### Remarks

The index of this field will be (RowID - 1), so "Islekeep's Stone Hatchet" appears at position 0.

| Improve this Doc View Source

#### UnlockedRecipes

A bitfield representing if a specific recipe (MJIRecipe) is unlocked. Backing field for IsRecipeUnlocked(UInt16), which should be used where possible.

##### Declaration

    public byte *UnlockedRecipes

##### Field Value

Type | Description
--- | ---
System.Byte* |

| Improve this Doc View Source

#### VillageDevelopmentLevel

The current development level of the player's village on their island. Controls what building zones are available.

##### Declaration

    public byte VillageDevelopmentLevel

##### Field Value

Type | Description
--- | ---
System.Byte |

##### Remarks

Allowed building locations are part of the MJIBuildingPlace (+0x10) and MJILandmarkPlace (+0x10) Lumina sheets.

| Improve this Doc View Source

#### Workshops

A struct representing the current state of workshops present on the island. See the struct documentation for more information on how to access this data.

Note that this struct only provides mapping from a workshop ID to other data.

##### Declaration

    public MJIWorkshops Workshops

##### Field Value

Type | Description
--- | ---
MJIWorkshops |